// Datei GleicheNamen01.c
/* ------------------------------------------------------------------------
Zwei verschieden Groessen (z.B. zwei Variablen oder eine Funktion und
eine Variable) muessen verschiedene Namen haben.
------------------------------------------------------------------------ */
#include <stdio.h>  // printf, sprintf, ...

enum MeinBool {false, true};

struct ZweiZahlen {
   int   z1;
   float z2;
};

       enum MeinBool mb01t = true;
       enum MeinBool mb01f = false;

extern enum MeinBool mb02t;
extern enum MeinBool mb02f;

       struct ZweiZahlen zz01 = {1, 1.5};
extern struct ZweiZahlen zz02;

void gibAusMeinBool02  (char * name, enum MeinBool mb);
void gibAusZweiZahlen02(char * name, struct ZweiZahlen zz);

void gibAusMeinBool01(char * name, enum MeinBool mb) {
   printf("gibAusMeinBool01(%s): %d\n", name, mb);
} // gibAusMeinBool01

void gibAusZweiZahlen01(char * name, struct ZweiZahlen zz) {
   printf("gibAusZweiZahlen01(%s): z1: %10d, z2: %10f\n", name, zz.z1, zz.z2);
} // gibAusZweiZahlen01

int main() {
   printf("GleicheNamen: Jetzt geht es los!\n");

   printf("--------------------------------------------------------\n");
   gibAusMeinBool01("mb01t", mb01t);
   gibAusMeinBool02("mb01t", mb01t);
   gibAusMeinBool01("mb01f", mb01f);
   gibAusMeinBool02("mb01f", mb01f);
   printf("--------------------------\n");
   gibAusMeinBool01("mb02t", mb02t);
   gibAusMeinBool02("mb02t", mb02t);
   gibAusMeinBool01("mb02f", mb02f);
   gibAusMeinBool02("mb02f", mb02f);
   printf("--------------------------------------------------------\n");
   gibAusZweiZahlen01("zz01", zz01);
   gibAusZweiZahlen02("zz01", zz01);
   gibAusZweiZahlen01("zz02", zz02);
   gibAusZweiZahlen02("zz02", zz02);
   printf("--------------------------------------------------------\n");

   return 0;
} // main
/* ------------------------------------------------------------------------
Ausgabe des Programms GleicheNamen:

GleicheNamen: Jetzt geht es los!
--------------------------------------------------------
gibAusMeinBool01(mb01t): 1
gibAusMeinBool02(mb01t): 1
gibAusMeinBool01(mb01f): 0
gibAusMeinBool02(mb01f): 0
--------------------------
gibAusMeinBool01(mb02t): 0
gibAusMeinBool02(mb02t): 0
gibAusMeinBool01(mb02f): 1
gibAusMeinBool02(mb02f): 1
--------------------------------------------------------
gibAusZweiZahlen01(zz01): z1:          1, z2:   1.500000
gibAusZweiZahlen02(zz01): z1:   0.000000, z2: 1069547520
gibAusZweiZahlen01(zz02): z1: 1069547520, z2:   0.000000
gibAusZweiZahlen02(zz02): z1:   1.500000, z2:          1
--------------------------------------------------------
------------------------------------------------------------------------ */
