// Datei StrToLong.c
/* ------------------------------------------------------------------------
Demonstriert die Funktion strtol (string to long)
------------------------------------------------------------------------ */
#include <stdio.h>   // E/A in Bytestroeme, printf, sprintf, ...
#include <stdlib.h>  // atof, atoi, rand, malloc, calloc, free, exit,
                     // bsearch, qsort, abs, div, ...
#include <errno.h>
#include <string.h>  // memcopy, memmove, strcpy, strcat, ...

#define TEST
#undef  TEST
// ------------------------------------------------------------------------
int main(void) {
   #define LEN 100

   char einBasis[LEN] = "";
   char einZahl [LEN] = "";

   char *   ptr;
   char * * pptr;
   int      basis;
   long     zahl;

   printf("StrToLong: Jetzt geht es los!\n");
   while (1) {
      printf("--------------------------------------------------\n");
      printf("Eine Basis (0 oder 2..36) oder 'q' zum Beenden: ");
      fgets(einBasis, LEN, stdin);
      einBasis[strlen(einBasis)-1] = '\0';
      if (strcmp(einBasis, "q") == 0) break;

      #ifdef TEST
      printf("einBasis: -->%s<--\n", einBasis);
      #endif

      sscanf(einBasis, "%i", &basis);
      if (basis !=0 && (basis < 2 || 36 < basis)) {
         printf("%d ist als Basis nicht erlaubt und wird "
                "durch 10 ersetzt!\n", basis);
         basis = 10;
      }

      printf("Eine Zahl (zur angegebenen Basis): ");
      fgets(einZahl, LEN, stdin);
      einZahl[strlen(einZahl)-1] = '\0';

      #ifdef TEST
      printf("einZahl:  -->%s<--\n", einZahl);
      #endif

      zahl = strtol(einZahl, pptr, basis);
      printf("Die Zahl: %ld (errno: %d, *pptr: %s)\n", zahl, errno, *pptr);
   }

   printf("StrToLong: Das war's erstmal!\n");
   return 0;
} // main
