// Datei IncludeAlle.c

#include <assert.h>  // Makro assert.
#include <ctype.h>   // isalpha, isdigit, islower, isupper, tolower, ...
#include <errno.h>   // errno, EDOM, ERANGE, ...
#include <float.h>   // FLT_MAX, FLT_MIN, DBL_MAX, DBL_MIN, ...
#include <inttypes.h>// PRId8, PRIdLEAST8, PRIdFAST8, ...
#include <iso646.h>  // and, or, xor, bitand, bitor, compl, not, ...
#include <limits.h>  // INT_MIN, INT_MAX, LONG_MIN, LONG_MAX, ...
#include <math.h>    // HUGE_VAL, sin, cos, tan, log, pow, sqrt, ...
#include <signal.h>  // Signale senden/fangen, signal, rais, SIG_DFL, SIG_IGN,
                     // SIGABRT, SIGFPE, SIGILL, SIGINT, SIGSEGV, SIGTERM, ...
#include <setjmp.h>  // Lange Rueckspruenge, jump_buf, setjmp, longjmp.
#include <stdarg.h>  // Ermoeglicht variable Anzahl von Parametern
#include <stdbool.h> // Makros bool, true, false.
#include <stddef.h>  // Typen ptrdiff_t, size_t, wchar_t, Konstante NULL
#include <stdint.h>  // int8_t, uint8_t, int_least8_t, uint_least8_t,
                     // int_fast8_t, intptr_t, uintptr_t, intmax_t, ...
#include <stdio.h>   // E/A in Bytestroeme, printf, scanf, sprintf, ...
#include <stdlib.h>  // atof, atoi, atol, rand, malloc, calloc, free, exit,
                     // abs, div, getenv, system, bsearch, qsort, ...
#include <string.h>  // memcopy, memmove, strcpy, strcat, ...
#include <time.h>    // tm_sec, tm_min, tm_hour, clock, time, ...

int main(void) {
   intmax_t intmax_t_v01 = +123456789012345678LL;
   intmax_t intmax_t_v02 = +1234567890123456789LL;
   intmax_t intmax_t_v03 = +12345678901234567890LL;
   int n01 = 0xFFFF0000;
   int n02 = 0xFF00FF00;

   printf("IncludeAlle: Jetzt geht es los!\n");
   printf("------------------------------------\n");
   printf("intmax_t_v01:   %+lld\n", intmax_t_v01);
   printf("intmax_t_v02:   %+lld\n", intmax_t_v02);
   printf("intmax_t_v03:   %+lld\n", intmax_t_v03);
   printf("------------------------------------\n");
   printf("n01:            %#010x\n", n01);
   printf("n02:            %#010x\n", n02);
   printf("n01 and    n02: %#010x\n", n01 and    n02);
   printf("n01 or     n02: %#010x\n", n01 or     n02);
   printf("-------------------------------\n");
   printf("n01 xor    n02: %#010x\n", n01 xor    n02);
   printf("n01 bitand n02: %#010x\n", n01 bitand n02);
   printf("n01 bitor  n02: %#010x\n", n01 bitor  n02);
   printf("-------------------------------\n");
   printf("IncludeAlle: Das war's erstmal!\n");
   return 0;
} // main
/* ------------------------------------------------------------------------
Ausgabe des Programms IncludeAlle:

IncludeAlle: Jetzt geht es los!
-------------------------------
n01:            0xffff0000
n02:            0xff00ff00
n01 and    n02: 0x00000001
n01 or     n02: 0x00000001
-------------------------------
n01 xor    n02: 0x00ffff00
n01 bitand n02: 0xff000000
n01 bitor  n02: 0xffffff00
-------------------------------
IncludeAlle: Das war's erstmal!
------------------------------------------------------------------------ */
