// Datei Zeiger07.c
#include <stdio.h>   // E/A in Bytestroeme, printf, sprintf, ...
/* ------------------------------------------------------------------------
Die Bytes einer Variablen namens var werden gleichzeitig als int- und
als float-Variable interpretiert. Der Benutzer kann einen Wert fuer
diese Bytes eingeben (wahlweise als int- oder als float-Zahl). Ein
paar darauf folgende Zahlen werden (als int- und als float-Zahl)
zur Standardausgabe ausgegeben.
------------------------------------------------------------------------ */
#define true    1 /* Weil der Borland-Compiler <stdbool> nicht kennt! */
#define MAXLEN 50 /* Groesse eines Einlesepuffers */
// ------------------------------------------------------------------------
void gibEvtlWarnungAus(void) {
   // Damit der Borland-Compiler nicht meckert werden hier
   // Variablen vereinbart (statt sizeof(...) direkt zu vergleichen):
   int sizeofInt   = sizeof(int);
   int sizeofFloat = sizeof(float);
   if (sizeofInt == sizeofFloat) return;
   printf("-------------------------------------------------\n");
   printf("sizeof(int) und sizeof(float) unterscheiden sich.\n");
   printf("Deshalb wird dieses Programm wohl nicht richtig  \n");
   printf("funktionieren!                                   \n");
   printf("-------------------------------------------------\n");
} // gibEvtlWarnungAus
// ------------------------------------------------------------------------
void gibBedienungsanleitungAus(void) {
   printf("-------------------------------------------------\n");
   printf("Bitte geben Sie jeweils ein:                     \n");
   printf("q (zum Beenden)             oder                 \n");
   printf("h (fuer diese Hilfemeldung) oder                 \n");
   printf("i und einen   int-Wert      oder                 \n");
   printf("f und einen float-Wert.                          \n");
   printf("-------------------------------------------------\n");
} // gibBedienungsanleitungAus
// ------------------------------------------------------------------------
void gibEinPaarZahlenAus(int * ai, float * af) {
   int i;
   for (i=1; i<=10; i++) {
      printf("*ai: %10d, *af: %1.21e\n", *ai, *af);
      (*ai)++;
   }
   printf("-------------------------------------------------\n");
} //gibEinPaarZahlenAus
// ------------------------------------------------------------------------
int main() {
   // Die folgende int-Variable bewirkt hoffentlich, dass die nachfolgende
   // char*-Variable "richtig ausgerichtet" ist (z.B. auf Wortgrenze):
   int     i;

   // Auf die Variable var kann man mit ai als int-Variable und mit
   // af als float-Variable zugreifen:
   char    var[sizeof(int)];
   int   * ai = (int   *) &var;
   float * af = (float *) &var;

   // Zum Einlesen von Daten:
   char    z;         // Fuer das erste Zeichen
   char    muell[50]; // Zum Ueberlesen von newline-Zeichen
   // ---------------------------------------------------------------------
   printf("Zeiger07: Jetzt geht es los!\n");

   gibEvtlWarnungAus();
   gibBedienungsanleitungAus();

   while (true) {
      printf("Eingabe? ");
      scanf ("%c", &z);
      if        (z == 'h' || z == 'H') {
         gibBedienungsanleitungAus();
      } else if (z == 'q' || z == 'Q') {
         break;
      } else if (z == 'f' || z == 'F') {
         scanf("%f", af);
         gibEinPaarZahlenAus(ai, af);
      } else if (z == 'i' || z == 'I') {
         scanf("%i", ai);
         gibEinPaarZahlenAus(ai, af);
      } else {
         gibBedienungsanleitungAus();
      } // if

      // Das newline-Zeichen am Ende der letzten Eingabe "ueberlesen":
      fgets(muell, MAXLEN, stdin);
   } // while

   printf("Zeiger07: Das war's erstmal!\n");

   return 0;
} // main
/* ------------------------------------------------------------------------
Ein Dialog mit dem Programm Zeiger07:

Zeiger07: Jetzt geht es los!
-------------------------------------------------
Bitte geben Sie jeweils ein:
q (zum Beenden)             oder
h (fuer diese Hilfemeldung) oder
i und einen   int-Wert      oder
f und einen float-Wert.
-------------------------------------------------
Eingabe? f0.1
*ai: 1036831949, *af: 1.000000014901161193848e-01
*ai: 1036831950, *af: 1.000000089406967163086e-01
*ai: 1036831951, *af: 1.000000163912773132324e-01
*ai: 1036831952, *af: 1.000000238418579101562e-01
*ai: 1036831953, *af: 1.000000312924385070801e-01
*ai: 1036831954, *af: 1.000000387430191040039e-01
*ai: 1036831955, *af: 1.000000461935997009277e-01
*ai: 1036831956, *af: 1.000000536441802978516e-01
*ai: 1036831957, *af: 1.000000610947608947754e-01
*ai: 1036831958, *af: 1.000000685453414916992e-01
-------------------------------------------------
Eingabe? i12345
*ai:      12345, *af: 1.729902954208986674055e-41
*ai:      12346, *af: 1.730043084055419155762e-41
*ai:      12347, *af: 1.730183213901851637470e-41
*ai:      12348, *af: 1.730323343748284119177e-41
*ai:      12349, *af: 1.730463473594716600884e-41
*ai:      12350, *af: 1.730603603441149082591e-41
*ai:      12351, *af: 1.730743733287581564298e-41
*ai:      12352, *af: 1.730883863134014046005e-41
*ai:      12353, *af: 1.731023992980446527712e-41
*ai:      12354, *af: 1.731164122826879009419e-41
-------------------------------------------------
Eingabe? q
Zeiger07: Das war's erstmal!
------------------------------------------------------------------------ */
