// Datei Bojen01.c
/* ----------------------------------------------------------
 * Gibt Variablen der Typen int, float, int*, und float*
 * als "querliegende Bojen" aus.
 * ---------------------------------------------------------- */
#include    <stdio.h> // printf, scanf, sprintf
//---------------------------------------------------------------
void bojeInt  (int   * adr, char * name) {
   // Gibt die int-Variabl *adr als querliegende Boje aus.
   printf("|%s|--<%X>--|%+d|\n", name, adr, *adr);
} // bojeInt
//---------------------------------------------------------------
void bojeFloat(float * adr, char * name) {
   // Gibt die float-Variabl *adr als querliegende Boje aus.
   printf("|%s|--<%X>--|%+3.1f|\n", name, adr, *adr);
} // bojeFloat
//---------------------------------------------------------------
void bojeIntAdr  (int   * * adr, char * name) {
   // Gibt die int*-Variable *adr als querliegende Boje aus.
   printf("|%s|--<%X>--|<%X>|--|%+d|\n",    name, adr, *adr, **adr);
} // bojeIntAdr
//---------------------------------------------------------------
void bojeFloatAdr(float * * adr, char * name) {
   // Gibt die float*-Variable *adr als querliegende Boje aus.
   printf("|%s|--<%X>--|<%X>|--|%+3.1f|\n", name, adr, *adr, **adr);
} // bojeFloatAdr
//---------------------------------------------------------------
int main() {
   int   anna = 123;
   int   bert = -45;

   float carl = 1.5;
   float dora = 2.3;

   int   * emma = &anna;
   int   * fred = &bert;

   float * gert = &carl;
   float * hana = &dora;

   printf("Bojen01: Jetzt geht es los!\n");
   printf("------------------------------------------------------\n");
   printf("int-Variablen    als querliegende Bojen:\n");
   bojeInt      (&anna, "anna");
   bojeInt      (&bert, "bert");
   printf("------------------------------------------------------\n");
   printf("float-Variablen  als querliegende Bojen:\n");
   bojeFloat    (&carl, "carl");
   bojeFloat    (&dora, "dora");
   printf("------------------------------------------------------\n");
   printf("int*-Variablen   als querliegende Bojen:\n");
   bojeIntAdr   (&emma, "emma");
   bojeIntAdr   (&fred, "fred");
   printf("------------------------------------------------------\n");
   printf("float*-Variablen als querliegende Bojen:\n");
   bojeFloatAdr (&gert, "gert");
   bojeFloatAdr (&hana, "hana");
   printf("------------------------------------------------------\n");
   printf("Bojen01: Das war's erstmal!\n");
   return 0;
} // main
/* ----------------------------------------------------------
Ausgabe des Programms Bojen01:

Bojen01: Jetzt geht es los!
------------------------------------------------------
int-Variablen    als querliegende Bojen:
|anna|--<22FEE4>--|+123|
|bert|--<22FEE0>--|-45|
------------------------------------------------------
float-Variablen  als querliegende Bojen:
|carl|--<22FEDC>--|+1.5|
|dora|--<22FED8>--|+2.3|
------------------------------------------------------
int*-Variablen   als querliegende Bojen:
|emma|--<22FED4>--|<22FEE4>|--|+123|
|fred|--<22FED0>--|<22FEE0>|--|-45|
------------------------------------------------------
float*-Variablen als querliegende Bojen:
|gert|--<22FECC>--|<22FEDC>|--|+1.5|
|hana|--<22FEC8>--|<22FED8>|--|+2.3|
------------------------------------------------------
Bojen01: Das war's erstmal!
---------------------------------------------------------- */
