// Datei Bojen04.c
/* ---------------------------------------------------------------------
Sei ir eine Reihung (z.B. von int-Variablen, siehe unten).
Mindestens 3 C-Compiler behandeln die Ausdruecke ir und &ir gleich,
naemlich als (konstante) Zeiger auf die erste Reihungskomponente.
Entspricht das dem Standard C99? Auf jeden Fall fuehrt es zu schwer
versteh- und erklaerbaren Phaenomenen, wie dieses Programm zeigen soll.
--------------------------------------------------------------------- */
#include    <stdio.h> // printf, scanf, sprintf
#define LEN 3

int   ir[LEN] = {0xCAFE, 0xBABE, 0x9999};
int * ia      = ir;

int main(void) {
   printf("Bojen04: Jetzt geht es los!\n");
   printf("------------------------------------------------\n");
   printf("A  ir   : %X, * ir   : %X\n",  ir,     *ir);
   printf("B &ir   : %X, *&ir   : %X\n", &ir,    *&ir);
   printf("C &ir[0]: %X, *&ir[0]: %X\n", &ir[0], *&ir[0]);
   printf("------------------------------------------------\n");
   printf("D  ia   : %X, * ia   : %X\n",  ia,     *ia);
   printf("E &ia   : %X, *&ia   : %X\n", &ia,    *&ia);
   printf("F &ia[0]: %X, *&ia[0]: %X\n", &ia[0], *&ia[0]);
   printf("------------------------------------------------\n");
   printf("Bojen04: Das war's erstmal!\n");
   return 0;
} // main
/* ---------------------------------------------------------------------
Ausgabe des Programms Bojen04 (compiliert mit dem Gnu-gcc):

Bojen04: Jetzt geht es los!
------------------------------------------------
A  ir   : 403010, * ir   : CAFE
B &ir   : 403010, *&ir   : 403010
C &ir[0]: 403010, *&ir[0]: CAFE
------------------------------------------------
D  ia   : 403010, * ia   : CAFE
E &ia   : 40301C, *&ia   : 403010
F &ia[0]: 403010, *&ia[0]: CAFE
------------------------------------------------
Bojen04: Das war's erstmal!
--------------------------------------------------------------------- */
