// Datei dat01.c
// ------------------------------------------------------
// Deklarationen von Groessen, die (hoffentlich) in
// anderen Dateien definiert werden:
// (Die Funktion quotient wird einmal richtig mit
// int-Parametern und einmal falsch mit float-Para-
// metern deklariert)

  int   summe   (int otto, int emil); // Mit  Param-Namen
  float quotient(int,   int);         // Ohne Param-Namen
//float quotient(float, float);       // Falsche Deklaration!
  int   printf  (const char *, ...);  // Ohne Param-Namen
// ------------------------------------------------------
// Definitionen von Groessen in dieser Datei:
unsigned int anzahlAufrufe;         // Anfangswert ist 0

int main(void) {
   printf("-------------------------\n");
   printf("summe   (+5, -3): %+7d\n",   summe   (+5, -3));
   printf("summe   (-2, -4): %+7d\n",   summe   (-2, -4));
   printf("-------------------------\n");
   printf("quotient(+7, +2): %+7.2f\n", quotient(+7, +2));
   printf("quotient(-7, +4): %+7.2f\n", quotient(-7, +4));
   printf("quotient(+7, -4): %+7.2f\n", quotient(+7, -4));
   printf("-------------------------\n");
   printf("Anzahl Aufrufe:   % 7d\n",   anzahlAufrufe);
   printf("-------------------------\n");
   return 0;
} // main
/* ------------------------------------------------------------------------
Ausgabe des Programms dat, wenn Zeile 11 auskommentiert und Zeile 10
gueltig ist:

-------------------------
summe   (+5, -3):      +2
summe   (-2, -4):      -6
-------------------------
quotient(+7, +2):   +3.50
quotient(-7, +4):   -1.75
quotient(+7, -4):   -1.75
-------------------------
Anzahl Aufrufe:         5
-------------------------
---------------------------------------------------------------------------
Ausgabe des Programms dat, wenn Zeile 10 auskommentiert und Zeile 11
gueltig ist:

-------------------------
summe   (+5, -3):      +2
summe   (-2, -4):      -6
-------------------------
quotient(+7, +2):   +1.01
quotient(-7, +4):   -0.98
quotient(+7, -4):   -1.02
-------------------------
Anzahl Aufrufe:         5
-------------------------
------------------------------------------------------------------------ */