// Datei v04.c
/* ------------------------------------------------------------------
 * Dieses Programm funktioniert nur, wenn int-Werte 32 und long long
 * Werte 64 Bit lang sind.
 * na ist eine long long Variable. ipa1 zeigt auf die "1.Haelfte"
 * von na und ipa2 zeigt auf die "2. Haelfte" von na.
 * Entsprechend fuer nb, nc und nd.
 * ----------------------------------------------------------------*/

#include <limits.h>
#include <stdio.h>

void druckeBinaer(long long n) {
	int i;
	int ziff;
	for (i=0; i<64; i++) {
		if (i>0 && i%8==0) printf(" ");
		ziff = n % 2;
		n    = n / 2;
		printf("%d", ziff);
	} // for
	printf("\n");
} // druckeBinaer

int main() {
	long long na = 1LL * (1LL + INT_MAX);
	long long nb = 2LL * (1LL + INT_MAX);
	long long nc = 4LL * (1LL + INT_MAX);
	long long nd = 8LL * (1LL + INT_MAX);
	
	int * ipa1 = (int *)           &na;
	int * ipa2 = (int *)(((char *) &na)+4);
	int * ipb1 = (int *)           &nb;
	int * ipb2 = (int *)(((char *) &nb)+4);
	int * ipc1 = (int *)           &nc;
	int * ipc2 = (int *)(((char *) &nc)+4);
	int * ipd1 = (int *)           &nd;
	int * ipd2 = (int *)(((char *) &nd)+4);

	printf("na   : %lld\n", na);
   druckeBinaer(na); 
	printf("*ipa1: %d, ", *ipa1);
	printf("*ipa2: %d\n", *ipa2);

	printf("nb   : %lld\n", nb);
   druckeBinaer(nb); 
	printf("*ipb1: %d, ", *ipb1);
	printf("*ipb2: %d\n", *ipb2);

	printf("nc   : %lld\n", nc);
   druckeBinaer(nc); 
	printf("*ipc1: %d, ", *ipc1);
	printf("*ipc2: %d\n", *ipc2);

	printf("nd   : %lld\n", nd);
   druckeBinaer(nd); 
	printf("*ipd1: %d, ", *ipd1);
	printf("*ipd2: %d\n", *ipd2);

} // main

